//***************************************************************************
// Group Linslot / Linux - Slotrace Manager
// File iothread.hpp
// Date 28.11.06 - Jrg Wendel
// This code is distributed under the terms and conditions of the
// GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
//***************************************************************************

#ifndef _IO_THREAD_H_
#define _IO_THREAD_H_

//***************************************************************************
// Includes
//***************************************************************************

#include <QThread>
// #include <QMutex>

#include <common.hpp>
#include <iointerface.hpp>

//***************************************************************************
// I/O Thread
//***************************************************************************

class IoThread : public QThread, public SlotService
{
      Q_OBJECT
      
   public:

      // object
      
      IoThread();
      virtual ~IoThread();

      // interface

      int init();
      int exit();
      int open();
      int close();
      void stop()                       { running = false; }
      void setTestMode(int aFlag)       { testMode = aFlag; }
      int writeBit(int bit, int value)  { return ioDevice->writeBit(bit, value); }
      int readOutBit(int bit)           { return ioDevice->readOutBit(bit); }
      void changeDevice(const char* dev);
      int waitByte(unsigned  char* byte, int byteNum);

      // get / set

      const char* getDevice()           { return device; }
      void setDevice(const char* dev);

   signals:

      void onIoSignal(const IoEvent &ioEvent);

   protected:
      
      void run();
      int atTrouble();

      // data

      char device[100+TB];
      int testMode;
      IoInterface* ioDevice;
      //  QMutex mutex;
      int running;
};

//***************************************************************************
#endif // _IO_THREAD_H_
